function collapseList() {
    $(".collapseList").each(function() {
        var listElm = $(this).get(0);
        // Check to see if this list item has already been parsed
        if (jQuery.data(listElm, "ParsedCollapse") != true) {
            // Not already parsed - add handlers
            $(this).children("li").each(function() {
                if ($(this).hasClass("open")) {
                    $(this).addClass("expOpen");
                    $(this).children("div").eq(0).show();
                } else {
                    $(this).addClass("expClosed");
                }

                // Add click binding
                $(this).children().eq(0).bind("click", function(event) {
                    toggleChildDiv($(this).parent(), event);
                });
                // Add to tab order (use child so whole nested list is not selected)
                $(this).children().eq(0).attr("tabindex", "0");
                // Add keypress binding
                $(this).children().eq(0).bind("keyup", function(event) {
                    var code=event.charCode || event.keyCode;
        		    if(code && code == 13) {// if enter is pressed
                        toggleChildDiv($(this).parent(), event);
                    }
                });
            });
        }
        // Set parsed flag
        jQuery.data(listElm, "ParsedCollapse", true);
    });
}

function toggleChildDiv(n, e) {
    $(n).toggleClass("expOpen");
    $(n).toggleClass("expClosed");
    if ($(n).hasClass("expOpen")) {
        $(n).children("div").eq(0).slideDown();
    } else {
        $(n).children("div").eq(0).slideUp();
    }
    e.stopPropagation();
}

function toggleChildList(n, e) {
    $(n).toggleClass("expOpen");
    if ($(n).hasClass("expOpen")) {
        $(n).children("ul").eq(0).slideDown();
    } else {
        $(n).children("ul").eq(0).slideUp();
    }
    e.stopPropagation();
}

function openAll() {
    $(".collapseList").each(function() {
        $(this).children("li").each(function() {
            $(this).removeClass("expOpen");
            $(this).removeClass("expClosed");
            $(this).addClass("expOpen");
            $(this).children("div").eq(0).show();
        });
    });
}

function closeAll() {
    $(".collapseList").each(function() {
        $(this).children("li").each(function() {
            $(this).removeClass("expOpen");
            $(this).removeClass("expClosed");
            $(this).addClass("expClosed");
            $(this).children("div").eq(0).hide();
        });
    });
}


$(window).ready(function() {
    collapseList();
});